#ifndef	VGAPAINT_CCYCLE_H
#define	VGAPAINT_CCYCLE_H

#include "vgapaint.h"

#ifdef	VGAPAINT_CCYCLE_C
#define	EXTERN
#define	INIT(x)	=x
#else
#define	EXTERN	extern
#define	INIT(x)
#endif

struct CycleStrip {
	uchar	start;
	uchar	end;
};

struct CycleRange {
	long	timer;			/* internal timer */
	long	speed;			/* speed in 1193181ths of a second */
	int	strips;			/* number of strips */
	struct	CycleStrip strip[32];	/* the strips */
};
EXTERN struct CycleRange *cyclerange;

//#define	CYCLE_TIMER	((short)(65536.0/18.2))

EXTERN boolean	ccycle_instd	INIT(FALSE);
EXTERN boolean	cyclehalt	INIT(FALSE);
EXTERN volatile uchar cyccol[256*3];
EXTERN void (__interrupt __far *prev_int_1c)(void);

EXTERN boolean	prtsc_instd	INIT(FALSE);
EXTERN ushort	prev_int_05_offset;
EXTERN ushort	prev_int_05_segment;
EXTERN ushort	prtsc_callback	INIT(0);

void	CCycle_Suspend(void);
void	CCycle_Resume(void);
void	CCycle_Install(void);
void	CCycle_Remove(void);
void	CCycle_Reset(void);
uchar *	CCycle_Unravel(short ccrange);

void PrtSc_Install(void);
void PrtSc_Remove(void);

void	CCycler(void);

#pragma aux CCycle_Interrupt loadds far;
void __far __loadds __interrupt CCycle_Interrupt(void);
//#pragma aux PrtSc_Interrupt loadds far;
//void __far __loadds __interrupt PrtSc_Interrupt(void);
void PrtSc_Interrupt(void);

void *Capture_Allocate_Memory(ulong size);

#undef INIT
#undef EXTERN

#endif

